//+------------------------------------------------------------------+
//|                                                Random_walker.mq4 |
//|                                                             Remo |
//|                                                                  |
//+------------------------------------------------------------------+
/*
This is a expert to figure out how to use most effective TakeProfit
and StopLoss lines to maximize profit but not cut to fast trade what happens
to move against direction expert excepts it to move.

Random walker opens trades randomly. it doesn't matter whisch way, good system
should be come out from wrong direction with some time and take some profit as well.

If StopLoss and TakeProfit are too close then it takes very fast risks what could
end up margin call and empty account balance. If the lines are too wide it takes
long time to get out of trade which means that the money management is not very
effective.
*/
#property copyright "Remo"
#property link      ""
#define MAGIC   28092005
extern int TakeProfit=150;
extern int StopLoss=35; 
extern double lTrailingStop = 20;
extern double sTrailingStop = 20;
extern int cnt;
extern int total;

 


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
int signal, random, random1, random2, signal2;
double Lots;
int Slippage=3; 
int hstTotal, klm, koku;
int total, cnt, ordertype; 



total=0;
for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() )
        {
         total++;
        }
     }
Comment(total+" "+Symbol());

MathSrand(LocalTime()); //to make even first number randomized 
random=MathRand();
random1=MathRand();
random2=MathRand();
if(random1<random2)signal=1; 
else signal=2;

Lots=0.1;

hstTotal=HistoryTotal();
if(total>0) return(0);
if(Volume[0]>1) return(0); //test shows best perfomance on 30m chart

if(koku==0)
{
for(klm=hstTotal;klm>0;klm--)
{
if(OrderSymbol()==Symbol()) klm=0;
{
if(OrderSelect(hstTotal-1,SELECT_BY_POS,MODE_HISTORY)==true)
{
   if(OrderProfit()<0) 
   {
   ordertype=OrderType();
   if(ordertype==1) signal=1;
   else signal=2;
   Lots=OrderLots()*1;
//      if(Lots>1.2) Lots=1.2;
   }//profit if
}//Orderselect if
}//Ordersymbol if
}//for
}//koku if
if(signal==1)
{
OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-(StopLoss*Point),Ask+(TakeProfit*Point),"RW BUY  "+MAGIC,0,0,White);
}
else
{
OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+(StopLoss*Point),Bid-(TakeProfit*Point),"RW SELL "+MAGIC,0,0,Red);
}
  
//----
   return(0);
  }
   
   for(cnt=0;cnt<total;cnt++) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol()) {
         if(OrderType()==OP_BUY){
            if(lTrailingStop>0) {
               if(Bid-OrderOpenPrice()>Point*lTrailingStop) {
                  if(OrderStopLoss()<Bid-Point*lTrailingStop) {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*lTrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                  }
               }
            }
         }else{
            if(sTrailingStop>0) {
               if((OrderOpenPrice()-Ask)>(Point*sTrailingStop)) {
                  if((OrderStopLoss()>(Ask+Point*sTrailingStop)) || (OrderStopLoss()==0)) {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*sTrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                  }
                  }
                  }
                  }
                  }
                  }
                 
                  
               
                 
//+------------------------------------------------------------------+

